#ifndef ACTION_H
#define ACTION_H

#include <stdint.h>
#include <stdio.h>
#include <vector>

typedef uint32_t Action;

#define Action_Wait 0
#define Action_MoveUp 1
#define Action_MoveDown 2
#define Action_MoveLeft 3
#define Action_MoveRight 4
#define Action_Abort 5
#define Action_Shave 6

#define acIsWait(ac) (ac == Action_Wait)
#define acIsMoveUp(ac) (ac == Action_MoveUp)
#define acIsMoveDown(ac) (ac == Action_MoveDown)
#define acIsMoveLeft(ac) (ac == Action_MoveLeft)
#define acIsMoveRight(ac) (ac == Action_MoveRight)
#define acIsAbort(ac) (ac == Action_Abort)
#define acIsShave(ac) (ac == Action_Shave)

void writeAction(FILE* f, Action action);
void writeTrace(FILE* f, const std::vector<Action>& trace);

#endif
