#ifndef DIFF_H
#define DIFF_H

#include <stdint.h>
#include "CellState.h"
#include "State.h"
#include "Pos.h"
#include <vector>
#include <set>

class Grid;
class GridInfo;

class CellDiff
{
public:
    CellDiff(Pos pos, CellState cellState)
        : m_pos(pos), m_cellState(cellState) {}

    Pos m_pos;
    CellState m_cellState;
};

class Diff
{
public:
    Diff();
    ~Diff();

    GridInfo* m_pInfo;
    std::vector<CellDiff> m_cells;
};

void applyDiff(Grid* pGrid, Diff* pDiff);
void concatDiff(const Grid& grid, const Diff& a, Diff* pB);

#endif
