#ifndef POS_H
#define POS_H

#include <stdint.h>

class Pos
{
public:
    Pos() : m_x(0), m_y(0) {}
    Pos(uint32_t x, uint32_t y) : m_x(x), m_y(y) {}

    bool operator==(const Pos& other) const {
        return m_y == other.m_y && m_x == other.m_x;
    }
    bool operator!=(const Pos& other) const {
        return m_y != other.m_y || m_x != other.m_x;
    }

    bool operator<(const Pos& other) const {
        if (m_y != other.m_y) {
            return m_y < other.m_y;
        }

        if (m_x != other.m_x) {
            return m_x < other.m_x;
        }

        return false;
    }

    uint32_t m_x;
    uint32_t m_y;
};

#endif
