#ifndef ZONE_H
#define ZONE_H

#include "Pos.h"
#include <stdint.h>
#include <vector>

class Grid;

typedef int32_t ZoneId;

class Zone
{
public:
    Zone();
    ~Zone();

    bool m_lift;
    bool m_lambda;
};

class ZoneMap
{
public:
    ZoneMap();
    ~ZoneMap();

    void resize(uint32_t width, uint32_t height);

    const ZoneId& cell(uint32_t x, uint32_t y) const {
        return m_data[y * (m_width+2) + x];
    }
    ZoneId& cell(uint32_t x, uint32_t y) {
        return m_data[y * (m_width+2) + x];
    }

    const ZoneId& cell(Pos pos) const {
        return m_data[pos.m_y * (m_width+2) + pos.m_x];
    }
    ZoneId& cell(Pos pos) {
        return m_data[pos.m_y * (m_width+2) + pos.m_x];
    }

    uint32_t m_width;
    uint32_t m_height;
    ZoneId* m_data;
    std::vector<Zone> m_zones;
    uint32_t m_zoneCount;
};

void makeZoneMap(ZoneMap* pZoneMap, const Grid& grid);

#endif
